var
  rs       : recordStore;
  data     : array[0..9] of string;
  tab      : array[0..1023] of boolean;
  width, height, scale : integer;
  x,y      : integer;
  xp,yp    : integer;
  key      : integer;
  i,j,n,bit: integer;
  //traf   : integer;
  b        : boolean;
  id_width, id_height, id_email, id_gauge, id_status : integer;
  menuCmd, editCmd, sendCmd, exitCmd, saveCmd, loadCmd, cmd  : command;
  name,hex: string;

procedure loadFromStr(s : string);
begin
  n := 0;
  width := ord(getChar(s,0));
  height := ord(getChar(s,1));
  for i := 2 to length(s)-1 do
  begin
    bit := pos(hex, getChar(s,i));
    n := n+4;
    for j := 1 to 4 do
    begin
      if (bit and 1)<>0 then tab[n-j]:=true else tab[n-j]:=false;
      bit := bit div 2;
    end;
  end;
end;


function toBits(count : integer) : string;  // count=width*height
var
  s : string;
begin
  s := '';
  i := 0;
  repeat
    n := 0;
    j := 0;
    repeat
      n:=n*2;
      if tab[i] then n:=n+1;
      i := i+1;
      j := j+1;
    until (j>=4);  //  -     hex-
    s := s+getChar(hex, n);
  until (i>=count);
  toBits := s;
end;


function send(data, width, height, eMail : string) : string;
var
  conn : http;
  s    : string;
begin
  send := '!     .    .';
  if openHttp(conn, 'http://bartwell.ru/j2me/emseditor.php?b='+data+'&w='+width+'&h='+height+'&e='+eMail) then
  begin
    setHttpMethod(conn, GET);
    //addHttpHeader(conn, 'User-agent', 'MIDletPascal browser');
    if sendHttpMessage(conn) = 200 then
    begin
      s := getHttpResponse(conn);
      if s='1' then send := s+chr(10)+'E-mail     !'
        else send := s+chr(10)+'   E-mail!        .';
      //s := getHttpHeader(conn, 'Content-type');
    end;
    closeHttp(conn);
  end;
end;


procedure mainMenu;
begin
  showForm;
  addCommand(editCmd);
  addCommand(saveCmd);
  addCommand(loadCmd);
  addCommand(sendCmd);
  addCommand(exitCmd);
  b := false;
  repeat
    delay(100);
    cmd := getClickedCommand;
    if (cmd=saveCmd) then
    begin
      xp := formGetValue(id_gauge);
      data[xp] := chr(width)+chr(height)+toBits(width*height);
      deleteRecordStore(name);
      rs := openRecordStore(name);
      for i := 0 to 9 do
        n := addRecordStoreEntry(rs,data[i]);
      closeRecordStore(rs);
      formRemove(id_status);
      id_status := formAddString('saved RMS '+xp+chr(10)+data[xp]);
    end;
    if (cmd=loadCmd) then
    begin
      formRemove(id_status);
      xp := formGetValue(id_gauge);
      if length(data[xp])>=8 then
      begin
        loadFromStr(data[xp]);
        formSetText(id_width, ''+width);
        formSetText(id_height, ''+height);
        id_status := formAddString('loaded RMS '+xp+chr(10)+data[xp]);
        b := true;
      end
        else id_status := formAddString('empty RMS '+xp);
    end;
    if (cmd=sendCmd) then
    begin
      formRemove(id_status);
      if formGetText(id_email)<>'' then
        id_status := formAddString(send(toBits(width*height), ''+width, ''+height, formGetText(id_email)));
        else id_status := formAddString(':  E-Mail!');
    end;
    if (cmd=editCmd) then b := true;
    if b then
    begin
      width := stringToInteger(formGetText(id_width));
      height := stringToInteger(formGetText(id_height));
      if ((width mod 8)<>0) or (width=0) then
      begin
        formRemove(id_status);
        id_status := formAddString(': WIDTH    8');
        b := false;
      end
      else
      if ((height mod 8)<>0) or (height=0) then
      begin
        formRemove(id_status);
        id_status := formAddString(': HEIGHT    8');
        b := false;
      end
      else
      if (width*height)>1024 then
      begin
        formRemove(id_status);
        id_status := formAddString(':   !'+chr(10)+' ');
        b := false;
      end;
    end;
    if (cmd=exitCmd) then  halt;
  until b;
  removeCommand(exitCmd);
  removeCommand(saveCmd);
  removeCommand(loadCmd);
  removeCommand(sendCmd);
  removeCommand(editCmd);
end;


procedure draw;
begin
  setColor(0,0,0);
  fillRect(0,0,getWidth,getHeight);
  setColor(0,255,0);
  drawText(''+x+':'+y, 0, 0);
  for i := 0 to height do drawLine(0, i*scale+17, width*scale, i*scale+17);
  for i := 0 to width  do drawLine(i*scale, 17, i*scale, height*scale+17);
  setColor(255,255,255);
  n := 0;
  for i := 0 to height-1 do
    for j := 0 to width-1  do
    begin
      if tab[n] then fillRect(j*scale+1, i*scale+1+17, scale-1, scale-1);
      n:=n+1;
    end;
  setColor(255,80,80);
  drawRect(x*scale, y*scale+17, scale, scale);
  repaint;
end;


procedure editor;
begin
  showCanvas;
  addCommand(menuCmd);
  x := (getWidth-1) div width;
  y := (getHeight-17) div height;
  scale := x;
  if y < scale then scale := y;  //  (.. )
  x:=0;
  y:=0;
  b:=true;
  repeat
    if b then
    begin
      draw;
      b := false;
    end;
    key := keyToAction(getKeyClicked);
    if (key=GA_UP)   then
    begin
      if y>0 then y:=y-1 else y:=height-1;
      b := true;
    end;
    if (key=GA_DOWN) then
    begin
      if y<height-1 then y:=y+1 else y:=0;
      b := true;
    end;
    if (key=GA_LEFT) then
    begin
      if x>0 then x:=x-1 else x:=width-1;
      b := true;
    end;
    if (key=GA_RIGHT)then
    begin
      if x<width-1 then x:=x+1 else x:=0;
      b := true;
    end;
    if (key=GA_FIRE) then
    begin
      i := y*width+x;
      tab[i] := not tab[i];
      b := true;
    end;
    if (key=GA_GAMEA) then
    begin
      xp := (getWidth-width) div 2;
      yp := (getHeight-height) div 2;
      setColor(255,255,255);
      fillRect(0,0,getWidth,getHeight);
      setColor(128,128,128);
      drawText('press Joystick key', 0, 0);
      drawRect(xp,yp,width+1,height+1);
      setColor(0,0,0);
      n := 0;
      for i := 0 to height-1 do
        for j := 0 to width-1  do
        begin
          if tab[n] then plot(xp+j+1, yp+i+1);
          n:=n+1;
        end;
      repaint;
    end;
    if (key=GA_GAMEB) then
    begin
      n := 0;
      for i := 1 to height do
        for j := 1 to width do
        begin
          tab[n] := not tab[n];
          n:=n+1;
        end;
      b := true;
    end;
    delay(100);
    cmd := getClickedCommand;
  until cmd<>emptyCommand;
  removeCommand(menuCmd);
end;


begin
  //traf := 0;
  hex := '0123456789abcdef';
  name := 'save';
  rs := openRecordStore(name);
  for i := 0 to 9 do
    data[i] := readRecordStoreEntry(rs,i+1);
  closeRecordStore(rs);
  for i := 0 to 1023 do tab[i] := false;
  menuCmd   := createCommand('MENU', CM_OK,     1);
  editCmd   := createCommand('EDIT', CM_ITEM,   1);
  saveCmd   := createCommand('SAVE', CM_ITEM,   2);
  loadCmd   := createCommand('LOAD', CM_ITEM,   3);
  sendCmd   := createCommand('SEND', CM_ITEM,   4);
  exitCmd   := createCommand('EXIT', CM_ITEM,   5);
  id_width  := formAddTextField('WIDTH x8', '8', 3, TF_NUMERIC);
  id_height := formAddTextField('HEIGHT x8', '8', 3, TF_NUMERIC);
  id_email  := formAddTextField('E-MAIL', 'your@mail.ru', 255, TF_EMAIL);
  id_gauge  := formAddGauge('choose rms record', true, 9, 0);
  id_status := formAddString('----------'+chr(10)+':'+chr(10)+' ,  ,     BMP-'+chr(10)+chr(10)+
               'programming by arT.  e-mail: ironwoodcutter@bk.ru'+chr(10)+chr(10)+
               ':'+chr(10)+'    . '+
               '  /   .      .'+chr(10)+chr(10)+
               ':'+chr(10)+'     E-mail.'+chr(10)+chr(10)+
               '[           BArtWell.Ru (WAP.BArtWell.Ru).'+chr(10)+
               '     ]');
  repeat
    mainMenu;
    editor;
  until false;
end.